/* GStreamer
 * Copyright (C) <1999> Erik Walthinsen <omega@cse.ogi.edu>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */


#ifndef __GST_EDITOR_CONNECTION_H__
#define __GST_EDITOR_CONNECTION_H__


#include <gst/editor/gsteditoritem.h>


#define GST_TYPE_EDITOR_CONNECTION (gst_editor_connection_get_type())
#define GST_EDITOR_CONNECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GST_TYPE_EDITOR_CONNECTION, GstEditorConnection))
#define GST_EDITOR_CONNECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GST_TYPE_EDITOR_CONNECTION, GstEditorConnectionClass))
#define GST_IS_EDITOR_CONNECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GST_TYPE_EDITOR_CONNECTION))
#define GST_IS_EDITOR_CONNECTION_CLASS(obj) (G_TYPE_CHECK_CLASS_TYPE ((klass), GST_TYPE_EDITOR_CONNECTION))
#define GST_EDITOR_CONNECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GTK_TYPE_EDITOR_CONNECTION, GstEditorConnectionClass))


struct _GstEditorConnection {
  GnomeCanvasLine line;

  /* the two pads we're connecting */
  GstEditorItem *srcpad, *sinkpad;

  /* toplevel canvas */
  GstEditorCanvas *canvas;

  /* whether we've been realized or not */
  gboolean realized;

  /* are we a ghosted connection? */
  gboolean ghost;

  /* are we a ghosted connection? */
  gboolean dragging;

  /* visual stuff */
  GnomeCanvasPoints *points;
  gdouble x,y;                                  /* terminating point	*/
};

struct _GstEditorConnectionClass {
  GnomeCanvasLineClass parent_class;
};


GType			gst_editor_connection_get_type		(void);
gboolean		gst_editor_connection_connect		(GstEditorConnection *connection);


#endif /* __GST_EDITOR_CONNECTION_H__ */
